package proba;

import java.awt.*;
import java.applet.*;
import java.awt.Color;
import java.util.Vector;
import java.awt.event.*;
/**
 * @author 	Alonso Ramirez
 * @version 	1.0
 * @since       JDK1.0
 */

public class AgenteViajero extends Applet implements ActionListener, Runnable{
	

	/**
	* Vector donde gaurdo lo estados 
	*/
	Vector vEstados = new Vector();
		
	int maxx=0,maxy=0; // coordenadas de la pantalla
	
	GeneradorU_0_1 g = new GeneradorU_0_1(500); // Un generador lineal congrencial
	
	double T=0.0; //La  temperatura inicial
	
	double alfa = 0.97; //la alfa de baja temperatura
	
	
	/**Interfas***************************************/
	Button bEjecutar = new Button("Procesar");
	Button bResetear = new Button("Random");
	Button bParar = new Button("Detener");
	Button bCirculo = new Button("Circulo");
	Button bGrid = new Button("Grid");
	TextField TFT = new TextField("");	
	TextField TFAlfa = new TextField("");	
	
	Label lbCosto = new Label("");
	Label lbCuenta = new Label("");
	Label lbEstadoT = new Label("");
	Label lbPCambio = new Label("");
	Thread th;
	
	Checkbox chkbIniRandom = new Checkbox("Los mismos?");
	
	Canvas canv = new Canvas();
	/*****************************************************/
	
	long cuenta= 0; // contador de iteraciones
	long cuentaError = 0; //contador de soluciones rechazadas 
	
	int nEstados = 60 ; //el numero de estados permitidos
	
	double costo = 0; //el costo actual en Pixeles
	
	/**
	 *Acomoda la interfas grafica y agrega las figuras a un vector
	 */ 
	 
	 
	 /**
	 * El iterador
	 */
	public void run(){
		while(procesa()){
			try{
				th.sleep(2);
			}catch(InterruptedException e){
				
			}
		}
		imprimeTerminado(); // muestra el resultado obtenido
	}
	
	/**
	*muestra el resultado obtenido
	*/
	public void imprimeTerminado(){
		Graphics g = canv.getGraphics();
		g.setColor(Color.white);
		g.setFont(new Font("TimesRoman",Font.BOLD,25));		
		g.drawString("Terminado costo ="+costo,10,maxy-10);
	}
	
	
	/**
	* Esta es la funcion principal, la que prueba los posibles cambios y descide si se hacen o no
	*/
	public boolean procesa(){
		//escojer 2 ligas aleatorias
		int ne1 = 0;
		int ne2 = 0;
		double deltaF;
		
		do{
			ne1 = (int)(g.obSig()*nEstados); //numero de 0 a nEstados-1
			ne2 = (int)(g.obSig()*nEstados);

		}while(Math.abs(ne1-ne2)<=1);

		
		if(ne1>ne2){
			int aux = ne1; ne1 = ne2 ;ne2=aux;	// ne2 siempre mayor que ne1
		}
		
		//calcula nuevo costo dadas 2 ligas a cambiar
		double newCosto = obtenNuevoCosto(ne1,ne2);
		
		deltaF = newCosto - costo; // la diferencia de ganancia
		
		cuenta++;
		lbCuenta.setText("Iteraciones: "+Integer.toString((int)cuenta));
		
		
		if(deltaF < -1.0){ // si hay ganancia
			cuentaError =0 ;
			costo = newCosto;
			lbCosto.setText("Costo: "+Double.toString(costo));

			//rearregla el vector dado un cambio
			reOrdenaLista(ne1,ne2);
			repaint(); //muestra el cambio
		}
		else{
			
			double valor = Math.exp(-deltaF/T); //calcula probabilidad exponencia
			if(valor == Double.NaN){
				valor = 0.0;
			}
			//generar un numero random
			double ran=g.obSig();
			
			if(ran<=valor ){
				//System.out.println("Cambio"+cuenta);
				cuentaError =0 ; //resetea el contador de errores
				costo = newCosto; //actualiza costo
				lbCosto.setText("Costo: "+Double.toString(costo)); // muestra el costo

				//rearregla el vector
				reOrdenaLista(ne1,ne2);
			
				repaint();
				
				lbEstadoT.setText(Double.toString(T));
				lbPCambio.setText(Double.toString(valor));
			}else{
				cuentaError ++; // no fue aceptado, hay que contar para salir 
			}
			//mostrar datos a interfas
			lbEstadoT.setText("T = "+Double.toString(T));
			lbPCambio.setText("P(Cambio Malo)= "+Double.toString(valor));
		}
		
		this.T = bajaTemperatura(this.T); // bajar la temperatura
		
		if(cuentaError > nEstados * nEstados)
			return false; //ya hubo muchos estados no aceptados, hay que salir
		
		return true; // continuar iterando
	}
	
	/**
	*Organiza toda la interfas grafica
	*/
	public void init() {
		Label lb1,lb2,lb3;
		Panel pN= new Panel();
		Panel pS= new Panel();
		pN.setLayout(new GridLayout(2,7));
		pS.setLayout(new GridLayout(1,4));
		
		pN.add(lb1 = new Label("T ="));
		pN.add(TFT);
		pN.add(lb2 = new Label("Alfa ="));
		pN.add(TFAlfa);
		pN.add(new Label(""));
		pN.add(bEjecutar);
		pN.add(bParar);

		pN.add(chkbIniRandom);
		pN.add(new Label(""));
		pN.add(new Label(""));
		pN.add(lb3 = new Label("Casos:"));
		pN.add(bResetear);
		pN.add(bCirculo);
		pN.add(bGrid);
		
		pS.add(lbCosto);
		pS.add(lbCuenta);
		pS.add(lbEstadoT);
		pS.add(lbPCambio);
		
		lb1.setAlignment(Label.RIGHT);
		lb2.setAlignment(Label.RIGHT);
		lb3.setAlignment(Label.RIGHT);
		
		lb1.setFont(new Font("",Font.BOLD,14));
		lb2.setFont(new Font("",Font.BOLD,14));
		lb3.setFont(new Font("",Font.BOLD,14));
		
		// acomodar interfas grafica
		setBackground(Color.white);
		setLayout(new BorderLayout());
		
		add(BorderLayout.NORTH,pN);
		add(BorderLayout.SOUTH,pS);
		add(BorderLayout.CENTER,canv);
		canv.setBackground(Color.black);
		
		bEjecutar.addActionListener(this);
		bResetear.addActionListener(this);
		bParar.addActionListener(this);
		bCirculo.addActionListener(this);
		bGrid.addActionListener(this);

		//inicializa a defaults
		TFT.setText("100000.0");	
		TFAlfa.setText("0.88");	
	}
	
	
	public void start(){
		maxx=canv.getSize().width;
		maxy=canv.getSize().height;
		iniRandom(); // inicializa con un recorrido random

	}
	/**
	* Baja la temperatura
	*/
	double bajaTemperatura(double pT){
		return alfa * pT;
	}
	
	/**
	*Actualiza los valores que ha tecleado en usuario
	*/
	public void iniProceso(){
		cuenta=0;
		cuentaError = 0;
		
		T=new Double(TFT.getText()).doubleValue();
		alfa = new Double(TFAlfa.getText()).doubleValue();

		if(chkbIniRandom.getState()==true)
			g = new GeneradorU_0_1(500);
	}
	
	/**
	* Genera el caso en que los estados estan distribuidos aleatoria e uniformemente  en la pantalla
	*
	*/
	public void iniRandom(){
		Estado e,e2 ;
		vEstados.removeAllElements();
		
		
		iniProceso();
		
		for(int i=0;i<nEstados;i++){
			e = new Estado(Integer.toString(i+1),randomX(),randomY());
			vEstados.addElement(e);
		}

		// calculo de costo inicial
		costoIni();
		
		repaint();
	}

	/**
	* Calcula la distancia entre 2 estados
	*/
	public double distancia(Estado e1, Estado e2){
		return Math.sqrt(Math.pow(e1.x-e2.x,2)+Math.pow(e1.y-e2.y,2));		
	}
	
	
	public void actionPerformed(ActionEvent e){
		if(e.getSource()== bEjecutar){
				if(th!= null && th.isAlive())
					return;
				th = new Thread(this);
				iniProceso();
				th.start();
		}
		else if(e.getSource()== bResetear){
			if(th != null && th.isAlive())
				th.stop();
				
			iniRandom();
		}
		else if(e.getSource()== bParar){
			if(th != null && th.isAlive())
				th.stop();
		}
		else if(e.getSource()== bCirculo){
			iniCirculo();
		}
		else if(e.getSource()== bGrid){
			iniGrid();
		}
	}
	/**
	* Genera el caso en que los estados estan en el perimetro de una
	*circunferencia
	*
	*/
	public void iniCirculo(){
		Estado e,e2 ;
		vEstados.removeAllElements();
		
		
		iniProceso();

		double seg=Math.PI/30,arg=0;
		double r = (double)(maxy) /(2.5) ;

		for(int i=0;i<nEstados;i++){
			int x=(int)(r*Math.cos(arg))+maxx/2;
			int y=(int)(r*Math.sin(arg))+maxy/2;
			
			e = new Estado(Integer.toString(i+1),x,y);
			vEstados.addElement(e);
			arg+=seg; 

		}
		
		//desacomodarlo
		for(int i=0;i<nEstados;i++){
			//obtener 2 random
			int ne1;
			int ne2;
			do{
				ne1 = (int)(g.obSig()*nEstados);	
				ne2 = (int)(g.obSig()*nEstados);	
			}while(ne1==ne2);
			if(ne2<ne1){
				int aux= ne1;
				ne1=ne2;
				ne2=aux;
			}
				
			e2 = (Estado)vEstados.elementAt(ne2);
			vEstados.removeElementAt(ne2);
			
			e = (Estado)vEstados.elementAt(ne1);
			vEstados.removeElementAt(ne1);
			
			vEstados.insertElementAt(e2,ne1);
			vEstados.insertElementAt(e,ne2);
		}
		
		
		// calculo de costo
		costoIni();
		repaint();
		
	}
	/**
	* Calcula el costo inicial
	*/
	public void costoIni(){
		Estado e,e2 ;
		costo =0.0;
		for(int i=1;i<vEstados.size();i++){
			e = (Estado)vEstados.elementAt(i-1);
			e2 = (Estado)vEstados.elementAt(i);
			
			costo += distancia(e,e2);
		}
		e = (Estado)vEstados.elementAt(0);
		e2 = (Estado)vEstados.elementAt(vEstados.size()-1);
		costo += distancia(e,e2);
		
		lbCosto.setText("Costo Ini: "+Double.toString(costo));
		
	}

	/**
	* Genera el caso en que los estados estan distribuidos en una cuadricula en la pantalla , donde la altura 
	* de cada rectangulo es diferente al ancho de los mismos.
	*
	*/
	public void iniGrid(){
		Estado e,e2 ;
		int nRenglones = 4;
		
		vEstados.removeAllElements();
		
		
		iniProceso();

		int x = 0;
		int y = 0 ;
		int tamRenglon = nEstados/nRenglones;
		int increx = (6 * maxx / 8) / tamRenglon;
		int increy = (7 * maxy / 8) / nRenglones;
		
		
		
		for(int i=0;i<nEstados;i++){
			
			e = new Estado(Integer.toString(i+1),maxx/8+x,maxy/8+y);
			
			x += increx;
			x = x % (6 * maxx / 8);
			y = ((int)((i+1) / tamRenglon))*increy;
			

			vEstados.addElement(e);

		}
		//desacomodarlo
		for(int i=0;i<nEstados;i++){
			//obtener 2 random
			int ne1;
			int ne2;
			do{
				ne1 = (int)(g.obSig()*nEstados);	
				ne2 = (int)(g.obSig()*nEstados);	
			}while(ne1==ne2);
			if(ne2<ne1){
				int aux= ne1;
				ne1=ne2;
				ne2=aux;
			}
				
			
			e2 = (Estado)vEstados.elementAt(ne2);
			vEstados.removeElementAt(ne2);
			
			e = (Estado)vEstados.elementAt(ne1);
			vEstados.removeElementAt(ne1);
			
			vEstados.insertElementAt(e2,ne1);
			vEstados.insertElementAt(e,ne2);
		}
		
		
		// calculo de costo
		costoIni();
		
		repaint();
		
	}
	
	/**
	*rearregla el vector dado un cambio
	*/
	public void	reOrdenaLista(int ne1,int ne2){
		Vector vPrim = new Vector();
		
		for(int c=0;c<ne2-ne1;c++){
			vPrim.addElement(vEstados.elementAt(ne1+1));	
			vEstados.removeElementAt(ne1+1);
		}
		
		for(int c=0;c<ne2-ne1;c++){
			vEstados.insertElementAt(vPrim.elementAt(c),ne1+1);	
		}		
	}
	
	/**
	*calcula nuevo costo dadas 2 ligas a cambiar
	*/
	public double obtenNuevoCosto(int liga1,int liga2){
		Estado e1,e2,e1p,e2p ;
		//obtener e1
		e1 = (Estado)vEstados.elementAt(liga1);
		//obtener e2
		e2 = (Estado)vEstados.elementAt(liga2);
		//obtener el siguiente de e1
		e1p = (Estado)vEstados.elementAt(liga1+1);
		//obtener el anterior de e2
		e2p = (Estado)vEstados.elementAt( (liga2+1) % vEstados.size());
		
		return costo - distancia( e1, e1p) - distancia( e2, e2p)
							+ distancia(e1,e2) + distancia(e1p,e2p);
	}

	/**
	* Dibuja los estados en la pantalla
	*/
	public void paint(Graphics g2) {
		Graphics g = canv.getGraphics();
		g.clearRect(0, 0, maxx, maxy);
		
		Estado x,y= new Estado("Dummy",10,10); //Dummy solo para evitar Warning
		
		x = (Estado) vEstados.elementAt(0);
		for(int i=1;i<vEstados.size();i++){
			y = (Estado) vEstados.elementAt(i);
			g.setColor(Color.green);
			g.drawLine(x.x , x.y , y.x , y.y);
			g.setColor(Color.white);
			g.drawString(y.descr , y.x , y.y );
			x = y;
		}
		x = (Estado) vEstados.elementAt(0);
		g.setColor(Color.green);
		g.drawLine(y.x , y.y , x.x , x.y);
		g.setColor(Color.white);
		g.drawString(x.descr , x.x , x.y );
		
			
	}
	/**
	* Da un numero random a lo ancho de la pantalla
	*/
	public int randomX(){
		return (int)(g.obSig()*maxx);
	}
	/**
	* Da un numero random a lo alto de  de la pantalla
	*/
	public int randomY(){
		return (int)(g.obSig()*maxy);
	}

}

/**
* Es la representacion abtracta de un estado
*/
class Estado{
	/**
	* Su coordenada x en la pantalla
	*/
	public int x;
	/**
	* Su coordenada y en la pantalla
	*/
	public int y;
	
	/**
	* Su descripcion
	*/
	public String descr;
	
	/**
	* Construye e inicializa
	*/
	Estado(String descr,int x,int y){
		this.x = x;
		this.y = y;
		this.descr = descr;
	}
	
}
